diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
index 92e8fa27b..ae1424cce 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/LanguagePackListComponent.java
@@ -2,12 +2,15 @@ package net.minecraft.client.gui.options.components;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.gui.options.ScreenOptions;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.lang.Language;
 import net.minecraft.core.lang.LanguageSeeker;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
 import org.slf4j.Logger;
 
 import java.io.IOException;
@@ -37,13 +40,13 @@ public class LanguagePackListComponent
 
     @Override
     public void init(Minecraft mc) {
-        buttons.clear();
+        this.buttons.clear();
 
         try {
-            languages = LanguageSeeker.getAvailableLanguages();
-            for (int i = 0; i < languages.size(); i++) {
-                Language language = languages.get(i);
-                buttons.add(new LanguagePackComponent(i, language));
+            this.languages = LanguageSeeker.getAvailableLanguages();
+            for (int i = 0; i < this.languages.size(); i++) {
+                Language language = this.languages.get(i);
+                this.buttons.add(new LanguagePackComponent(i, language));
             }
         } catch (IOException e) {
             LOGGER.error("Exception while getting available languages!", e);
@@ -52,21 +55,21 @@ public class LanguagePackListComponent
 
     @Override
     public int getHeight() {
-        return buttons.size() * BUTTON_HEIGHT;
+        return this.buttons.size() * BUTTON_HEIGHT;
     }
 
     @Override
-    public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-        for (int i = 0; i < buttons.size(); i++) {
-            LanguagePackComponent button = buttons.get(i);
+    public void render(@NotNull ScreenOptions screenOptions, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+        for (int i = 0; i < this.buttons.size(); i++) {
+            LanguagePackComponent button = this.buttons.get(i);
             button.render(x, 3 + y + i * (BUTTON_HEIGHT + 3), width, relativeMouseX, relativeMouseY);
         }
     }
 
     @Override
     public void onMouseClick(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-        for (int i = 0; i < buttons.size(); i++) {
-            LanguagePackComponent button = buttons.get(i);
+        for (int i = 0; i < this.buttons.size(); i++) {
+            LanguagePackComponent button = this.buttons.get(i);
             if (relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= 3 + i * (BUTTON_HEIGHT + 3) && relativeMouseY <= 3 + i * (BUTTON_HEIGHT + 3) + BUTTON_HEIGHT) {
                 String lang = button.languagePack.getId();
                 mc.gameSettings.language.set(lang);
@@ -77,13 +80,16 @@ public class LanguagePackListComponent
     }
 
     @Override
-    public void onMouseMove(int x, int y, int width, int relativeMouseX, int relativeMouseY) { }
+    public void onMouseMove(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+    }
 
     @Override
-    public void onMouseRelease(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) { }
+    public void onMouseRelease(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+    }
 
     @Override
-    public void onKeyPress(int keyCode, char character) { }
+    public void onKeyPress(int keyCode, char character) {
+    }
 
     @Override
     public boolean matchesSearchTerm(String term) {
@@ -91,7 +97,7 @@ public class LanguagePackListComponent
     }
 
     private static class LanguagePackComponent {
-    	private final Minecraft mc = Minecraft.getMinecraft();
+        private final Minecraft mc = Minecraft.getMinecraft();
         public final int index;
         public final Language languagePack;
         public final int height = BUTTON_HEIGHT;
@@ -102,32 +108,32 @@ public class LanguagePackListComponent
         }
 
         public void render(int x, int y, int width, int mouseX, int mouseY) {
-            Tessellator tessellator = Tessellator.instance;
-
-            if (mc.gameSettings.language.value.equals(languagePack.getId())) {
+            if (this.mc.gameSettings.language.value.equals(this.languagePack.getId())) {
                 // Draw background
-                GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-                GL11.glDisable(GL11.GL_TEXTURE_2D);
+                GLRenderer.pushFrame();
+                GLRenderer.setShader(Shaders.COLOR);
+                GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+                TessellatorGeneral tessellator = GLRenderer.getTessellator();
                 tessellator.startDrawingQuads();
 
-                tessellator.setColorOpaque_I(0x7F808080);
-                tessellator.addVertexWithUV(x - 2, y + height + 2, 0, 0, 1);
-                tessellator.addVertexWithUV(x + width + 2, y + height + 2, 0, 1, 1);
+                tessellator.setColorOpaque1i(0x7F808080);
+                tessellator.addVertexWithUV(x - 2, y + this.height + 2, 0, 0, 1);
+                tessellator.addVertexWithUV(x + width + 2, y + this.height + 2, 0, 1, 1);
                 tessellator.addVertexWithUV(x + width + 2, y - 2, 0, 1, 1);
                 tessellator.addVertexWithUV(x - 2, y - 2, 0, 0, 0);
 
-                tessellator.setColorOpaque_I(0);
-                tessellator.addVertexWithUV(x - 1, y + height + 1, 0, 0, 1);
-                tessellator.addVertexWithUV(x + width + 1, y + height + 1, 0, 1, 1);
+                tessellator.setColorOpaque1i(0);
+                tessellator.addVertexWithUV(x - 1, y + this.height + 1, 0, 0, 1);
+                tessellator.addVertexWithUV(x + width + 1, y + this.height + 1, 0, 1, 1);
                 tessellator.addVertexWithUV(x + width + 1, y - 1, 0, 1, 1);
                 tessellator.addVertexWithUV(x - 1, y - 1, 0, 0, 0);
 
                 tessellator.draw();
-                GL11.glEnable(GL11.GL_TEXTURE_2D);
+                GLRenderer.popFrame();
             }
             StringBuilder sb = new StringBuilder();
-            String name = languagePack.getName();
-            String region = languagePack.getRegion();
+            String name = this.languagePack.getName();
+            String region = this.languagePack.getRegion();
             if (name != null) {
                 sb.append(name);
             } else {
@@ -138,7 +144,7 @@ public class LanguagePackListComponent
             }
             final String fullName = sb.toString();
             final StringBuilder credits = new StringBuilder();
-            final Iterator<String> creditsList = languagePack.getCredits().listIterator();
+            final Iterator<String> creditsList = this.languagePack.getCredits().listIterator();
             boolean empty = true;
             while (creditsList.hasNext()) {
                 credits.append(creditsList.next());
@@ -147,8 +153,8 @@ public class LanguagePackListComponent
                 }
                 empty = false;
             }
-            this.mc.font.renderCentered(Tessellator.instance, fullName, x + (width / 2), y + 1).setShadow().call();
-            this.mc.font.renderCentered(Tessellator.instance, empty ? "Unknown Credits" : credits, x + width / 2, y + 12).setShadow().setColor(0x808080).call();
+            this.mc.font.renderCentered(fullName, x + (width / 2), y + 1).setShadow().call();
+            this.mc.font.renderCentered(empty ? "Unknown Credits" : credits, x + width / 2, y + 12).setShadow().setColor(0x808080).call();
         }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsCategory.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsCategory.java
index 15babdda7..9935b5261 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsCategory.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsCategory.java
@@ -2,18 +2,18 @@ package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ItemElement;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.gui.options.ScreenOptions;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.ArrayList;
 import java.util.List;
 
 public class OptionsCategory
-    implements OptionsComponent
-{
+    implements OptionsComponent {
     private static final Minecraft mc = Minecraft.getMinecraft();
     private static final ItemElement renderItem = new ItemElement(mc);
     private static final int PADDING = 2;
@@ -32,34 +32,30 @@ public class OptionsCategory
     private final @Nullable String tooltipTranslationKey;
     private @Nullable String shownTooltipTranslationKey = null;
 
-    public OptionsCategory(String translationKey)
-    {
+    public OptionsCategory(String translationKey) {
         this(translationKey, null);
     }
 
-    public OptionsCategory(String translationKey, ItemStack icon)
-    {
+    public OptionsCategory(String translationKey, ItemStack icon) {
         this(translationKey, icon, null);
     }
 
-    public OptionsCategory(String translationKey, ItemStack icon, @Nullable String tooltipTranslationKey)
-    {
+    public OptionsCategory(String translationKey, ItemStack icon, @Nullable String tooltipTranslationKey) {
         this.translationKey = translationKey;
         this.tooltipTranslationKey = tooltipTranslationKey;
         this.icon = icon;
     }
 
-    public OptionsCategory withComponent(OptionsComponent component)
-    {
+    public OptionsCategory withComponent(OptionsComponent component) {
         if (component != null) {
-            components.add(component);
+            this.components.add(component);
         }
         return this;
     }
 
     @Override
     public void init(Minecraft mc) {
-        for (OptionsComponent component : components) {
+        for (OptionsComponent component : this.components) {
             component.init(mc);
         }
     }
@@ -71,19 +67,16 @@ public class OptionsCategory
 
     @Override
     public void tick() {
-        for (OptionsComponent component : components)
-        {
+        for (OptionsComponent component : this.components) {
             component.tick();
         }
     }
 
     @Override
-    public int getHeight()
-    {
+    public int getHeight() {
         int height = TOP_SPACING;
-        if (!collapsed) {
-            for (OptionsComponent component : components)
-            {
+        if (!this.collapsed) {
+            for (OptionsComponent component : this.components) {
                 height += component.getHeight();
             }
         }
@@ -91,31 +84,29 @@ public class OptionsCategory
     }
 
     @Override
-    public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY)
-    {
+    public void render(@NotNull ScreenOptions screenOptions, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
         I18n i18n = I18n.getInstance();
         int textColor = 0x7F7F7F;
         this.shownTooltipTranslationKey = null;
-        if (relativeMouseX >= 0 && relativeMouseX < width && relativeMouseY >= 0 && relativeMouseY < TOP_SPACING)
-        {
+        if (relativeMouseX >= 0 && relativeMouseX < width && relativeMouseY >= 0 && relativeMouseY < TOP_SPACING) {
             textColor = 0xFFFFA0;
             this.shownTooltipTranslationKey = this.tooltipTranslationKey;
 
         }
-        mc.font.render(Tessellator.instance, (this.collapsed ? "▷" : "▽"), x, y + PADDING + 10).setShadow().setColor(textColor).call();
+        mc.font.render((this.collapsed ? "▷" : "▽"), x, y + PADDING + 10).setShadow().setColor(textColor).call();
 
         int xOffset = 10;
-        if (icon != null)
-        {
-            renderItem.render(icon, x + 11, y + PADDING + 5);
+        if (this.icon != null) {
+            renderItem.render(this.icon, x + 11, y + PADDING + 5);
             xOffset += 20;
         }
-        mc.font.render(Tessellator.instance, i18n.translateKey(this.translationKey), x + xOffset, y + PADDING + 10).setShadow().setColor(textColor).call();
-        if (!collapsed) {
+        mc.font.render(i18n.translateKey(this.translationKey), x + xOffset, y + PADDING + 10).setShadow().setColor(textColor).call();
+        if (!this.collapsed) {
             int componentY = TOP_SPACING;
-            for (OptionsComponent component : components)
-            {
-                component.render(x + COMPONENT_LEFT_MARGIN, y + componentY, width - COMPONENT_LEFT_MARGIN, relativeMouseX - COMPONENT_LEFT_MARGIN, relativeMouseY - componentY);
+            for (OptionsComponent component : this.components) {
+                if (y + componentY + component.getHeight() >= screenOptions.top && y + componentY <= screenOptions.bottom) {
+                    component.render(screenOptions, x + COMPONENT_LEFT_MARGIN, y + componentY, width - COMPONENT_LEFT_MARGIN, relativeMouseX - COMPONENT_LEFT_MARGIN, relativeMouseY - componentY);
+                }
                 componentY += component.getHeight();
 
                 @Nullable String componentTooltipTranslationKey = component.getTooltipTranslationKey();
@@ -127,19 +118,17 @@ public class OptionsCategory
     }
 
     @Override
-    public void onMouseClick(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY)
-    {
-        if (relativeMouseX >= 0 && relativeMouseX < width && relativeMouseY >= 0 && relativeMouseY < TOP_SPACING)
-        {
-            collapsed = !collapsed;
+    public void onMouseClick(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+        if (relativeMouseX >= 0 && relativeMouseX < width && relativeMouseY >= 0 && relativeMouseY < TOP_SPACING) {
+            this.collapsed = !this.collapsed;
             mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
         }
         int componentY = TOP_SPACING;
-        for (OptionsComponent component : components) {
+        for (OptionsComponent component : this.components) {
             if (relativeMouseX >= COMPONENT_LEFT_MARGIN && relativeMouseX < width && relativeMouseY >= componentY && relativeMouseY < componentY + component.getHeight()) {
                 component.onMouseClick(mouseButton, x + COMPONENT_LEFT_MARGIN, componentY, width - COMPONENT_LEFT_MARGIN, relativeMouseX - COMPONENT_LEFT_MARGIN, relativeMouseY - componentY);
-                clickedComponent = component;
-                clickedComponentY = componentY;
+                this.clickedComponent = component;
+                this.clickedComponentY = componentY;
                 return;
             }
             componentY += component.getHeight();
@@ -148,39 +137,33 @@ public class OptionsCategory
 
     @Override
     public void onMouseMove(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-        if (clickedComponent != null) {
-            clickedComponent.onMouseMove(x + COMPONENT_LEFT_MARGIN, clickedComponentY, width - COMPONENT_LEFT_MARGIN, relativeMouseX - COMPONENT_LEFT_MARGIN, relativeMouseY - clickedComponentY);
+        if (this.clickedComponent != null) {
+            this.clickedComponent.onMouseMove(x + COMPONENT_LEFT_MARGIN, this.clickedComponentY, width - COMPONENT_LEFT_MARGIN, relativeMouseX - COMPONENT_LEFT_MARGIN, relativeMouseY - this.clickedComponentY);
         }
     }
 
     @Override
     public void onMouseRelease(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-        if (clickedComponent != null) {
-            clickedComponent.onMouseRelease(mouseButton, x + COMPONENT_LEFT_MARGIN, clickedComponentY, width - COMPONENT_LEFT_MARGIN, relativeMouseX - COMPONENT_LEFT_MARGIN, relativeMouseY - clickedComponentY);
+        if (this.clickedComponent != null) {
+            this.clickedComponent.onMouseRelease(mouseButton, x + COMPONENT_LEFT_MARGIN, this.clickedComponentY, width - COMPONENT_LEFT_MARGIN, relativeMouseX - COMPONENT_LEFT_MARGIN, relativeMouseY - this.clickedComponentY);
         }
     }
 
     @Override
-    public void onKeyPress(int keyCode, char character)
-    {
-        for (OptionsComponent component : components)
-        {
+    public void onKeyPress(int keyCode, char character) {
+        for (OptionsComponent component : this.components) {
             component.onKeyPress(keyCode, character);
         }
     }
 
-    public OptionsCategory filter(String term)
-    {
-        OptionsCategory category = new OptionsCategory(translationKey);
-        for (OptionsComponent component : components)
-        {
-            if (component.matchesSearchTerm(term))
-            {
+    public OptionsCategory filter(String term) {
+        OptionsCategory category = new OptionsCategory(this.translationKey);
+        for (OptionsComponent component : this.components) {
+            if (component.matchesSearchTerm(term)) {
                 category.withComponent(component);
             }
         }
-        if (category.components.isEmpty())
-        {
+        if (category.components.isEmpty()) {
             return null;
         }
         return category;
@@ -188,14 +171,13 @@ public class OptionsCategory
 
     @Override
     public void onClose() {
-        for (OptionsComponent component : components) {
+        for (OptionsComponent component : this.components) {
             component.onClose();
         }
     }
 
     @Override
-    public boolean matchesSearchTerm(String term)
-    {
+    public boolean matchesSearchTerm(String term) {
         return false;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsComponent.java
index 96466a400..e8fd06b19 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/OptionsComponent.java
@@ -1,6 +1,8 @@
 package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.options.ScreenOptions;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public interface OptionsComponent
@@ -11,7 +13,7 @@ public interface OptionsComponent
 
     int getHeight();
 
-    void render(int x, int y, int width, int relativeMouseX, int relativeMouseY);
+    void render(@NotNull ScreenOptions screenOptions, int x, int y, int width, int relativeMouseX, int relativeMouseY);
 
     default void tick() { }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/SearchFieldComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/SearchFieldComponent.java
index 9c1200fc3..6cd7573c0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/SearchFieldComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/SearchFieldComponent.java
@@ -3,10 +3,12 @@ package net.minecraft.client.gui.options.components;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.TextFieldElement;
+import net.minecraft.client.gui.options.ScreenOptions;
 import net.minecraft.client.gui.options.data.OptionsPage;
 import net.minecraft.client.gui.options.data.OptionsPageRegistry;
 import net.minecraft.client.gui.text.TextFieldEditor;
 import net.minecraft.core.sound.SoundCategory;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Keyboard;
 
@@ -27,21 +29,21 @@ public class SearchFieldComponent
     private OptionsComponent clickedComponent = null;
     private int clickedComponentY = 0;
 
-    private ButtonElement clearButton;
+    private final ButtonElement clearButton;
 
     public SearchFieldComponent() {
-        textField = new TextFieldElement(mc.currentScreen, mc.font, 0, 0, 150, 18, "", "Search...");
-        textField.setMaxStringLength(20);
-        textField.setTextChangeListener(this);
-        editor = new TextFieldEditor(textField);
-        clearButton = new ButtonElement(0, 0, 0, 12, 20, "")
+        this.textField = new TextFieldElement(mc.currentScreen, mc.font, 0, 0, 150, 18, "", "Search...");
+        this.textField.setMaxStringLength(20);
+        this.textField.setTextChangeListener(this);
+        this.editor = new TextFieldEditor(this.textField);
+        this.clearButton = new ButtonElement(0, 0, 0, 12, 20, "")
             .setTextures("minecraft:gui/screen/options/clear", "minecraft:gui/screen/options/clear_highlighted", null);
     }
 
     @Override
     public void init(final Minecraft mc) {
         OptionsComponent.super.init(mc);
-        textField.parent = mc.currentScreen;
+        this.textField.parent = mc.currentScreen;
     }
 
     @Override
@@ -51,58 +53,60 @@ public class SearchFieldComponent
 
     @Override
     public void tick() {
-        textField.updateCursorCounter();
+        this.textField.updateCursorCounter();
 
-        for (OptionsComponent component : components) {
+        for (OptionsComponent component : this.components) {
             component.tick();
         }
     }
 
     @Override
     public int getHeight() {
-        int height = PADDING + textField.height + PADDING;
-        for (OptionsComponent component : components) {
+        int height = PADDING + this.textField.height + PADDING;
+        for (OptionsComponent component : this.components) {
             height += component.getHeight();
         }
         return height;
     }
 
     @Override
-    public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-        textField.xPosition = x + width / 2 - textField.width / 2;
-        textField.yPosition = y + PADDING;
+    public void render(@NotNull ScreenOptions screenOptions, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+        this.textField.xPosition = x + width / 2 - this.textField.width / 2;
+        this.textField.yPosition = y + PADDING;
 
-        textField.drawTextBox();
-        textField.updateCursor(mc, x + relativeMouseX, y + relativeMouseY);
+        this.textField.drawTextBox();
+        this.textField.updateCursor(mc, x + relativeMouseX, y + relativeMouseY);
 
-        clearButton.xPosition = x + width / 2 + textField.width / 2 + 1;
-        clearButton.yPosition = y + PADDING - 1;
-        clearButton.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
+        this.clearButton.xPosition = x + width / 2 + this.textField.width / 2 + 1;
+        this.clearButton.yPosition = y + PADDING - 1;
+        this.clearButton.drawButton(mc, x + relativeMouseX, y + relativeMouseY);
 
-        int componentY = PADDING + textField.height + PADDING;
-        for (OptionsComponent component : components) {
-            component.render(x, y + componentY, width, relativeMouseX, relativeMouseY - componentY);
+        int componentY = PADDING + this.textField.height + PADDING;
+        for (OptionsComponent component : this.components) {
+            if (y + componentY + component.getHeight() >= screenOptions.top && y + componentY <= screenOptions.bottom) {
+                component.render(screenOptions, x, y + componentY, width, relativeMouseX, relativeMouseY - componentY);
+            }
             componentY += component.getHeight();
         }
     }
 
     @Override
     public void onMouseClick(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-        textField.mouseClicked(x + relativeMouseX, y + relativeMouseY, 0);
+        this.textField.mouseClicked(x + relativeMouseX, y + relativeMouseY, 0);
 
-        if (clearButton.mouseClicked(mc, x + relativeMouseX, y + relativeMouseY)) {
+        if (this.clearButton.mouseClicked(mc, x + relativeMouseX, y + relativeMouseY)) {
             mc.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
-            textField.setText("");
+            this.textField.setText("");
             updateSearchResults("");
             return;
         }
 
-        int componentY = PADDING + textField.height + PADDING;
-        for (OptionsComponent component : components) {
+        int componentY = PADDING + this.textField.height + PADDING;
+        for (OptionsComponent component : this.components) {
             if (relativeMouseX >= 0 && relativeMouseX < width && relativeMouseY >= componentY && relativeMouseY < componentY + component.getHeight()) {
                 component.onMouseClick(mouseButton, x, componentY, width, relativeMouseX, relativeMouseY - componentY);
-                clickedComponent = component;
-                clickedComponentY = componentY;
+                this.clickedComponent = component;
+                this.clickedComponentY = componentY;
                 return;
             }
             componentY += component.getHeight();
@@ -111,26 +115,26 @@ public class SearchFieldComponent
 
     @Override
     public void onMouseMove(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-        if (clickedComponent != null) {
-            clickedComponent.onMouseMove(x, clickedComponentY, width, relativeMouseX, relativeMouseY - clickedComponentY);
+        if (this.clickedComponent != null) {
+            this.clickedComponent.onMouseMove(x, this.clickedComponentY, width, relativeMouseX, relativeMouseY - this.clickedComponentY);
         }
     }
 
     @Override
     public void onMouseRelease(int mouseButton, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
-        if (clickedComponent != null) {
-            clickedComponent.onMouseRelease(mouseButton, x, clickedComponentY, width, relativeMouseX, relativeMouseY - clickedComponentY);
+        if (this.clickedComponent != null) {
+            this.clickedComponent.onMouseRelease(mouseButton, x, this.clickedComponentY, width, relativeMouseX, relativeMouseY - this.clickedComponentY);
         }
     }
 
     @Override
     public void onKeyPress(int keyCode, char character) {
-        if (textField.isFocused && keyCode != Keyboard.KEY_ESCAPE) {
-            textField.textboxKeyTyped(character, keyCode);
+        if (this.textField.isFocused && keyCode != Keyboard.KEY_ESCAPE) {
+            this.textField.textboxKeyTyped(character, keyCode);
         } else if (keyCode == Keyboard.KEY_ESCAPE) {
-            textField.setFocused(false);
+            this.textField.setFocused(false);
         } else {
-            for (OptionsComponent component : components) {
+            for (OptionsComponent component : this.components) {
                 component.onKeyPress(keyCode, character);
             }
         }
@@ -147,7 +151,7 @@ public class SearchFieldComponent
     }
 
     private void updateSearchResults(String searchTerm) {
-        components.clear();
+        this.components.clear();
         if (searchTerm.isEmpty()) {
             return;
         }
@@ -158,8 +162,7 @@ public class SearchFieldComponent
             OptionsCategory pageCategory = new OptionsCategory(page.getTranslationKey(), page.getIcon());
             boolean hasComponents = false;
             for (OptionsComponent component : page.getComponents()) {
-                if (component instanceof OptionsCategory) {
-                    OptionsCategory category = (OptionsCategory) component;
+                if (component instanceof OptionsCategory category) {
                     OptionsCategory filtered = category.filter(searchTerm);
                     if (filtered != null) {
                         pageCategory.withComponent(filtered);
@@ -171,7 +174,7 @@ public class SearchFieldComponent
                 }
             }
             if (hasComponents) {
-                components.add(pageCategory);
+                this.components.add(pageCategory);
             }
         }
     }
